#include "skse64/NiRTTI.h"
#include "skse64/NiObjects.h"

NiObject * DoNiRTTICast(NiObject * src, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (src)
		for (NiRTTI * iter = src->GetRTTI(); iter; iter = iter->parent)
			if (iter == (NiRTTI *)typeAddr)
				return src;

	return nullptr;
}

bool IsType(NiRTTI * rtti, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (rtti)
		return uintptr_t(rtti) == typeAddr;

	return false;
}

const NiRTTI * NiRTTI_BGSDecalNode = (NiRTTI *)0x01F57FA0;
const NiRTTI * NiRTTI_BSAnimGroupSequence = (NiRTTI *)0x01F58100;
const NiRTTI * NiRTTI_BSSplatterExtraData = (NiRTTI *)0x02F59150;
const NiRTTI * NiRTTI_BGSAddonNodeSoundHandleExtra = (NiRTTI *)0x02F595B8;
const NiRTTI * NiRTTI_REFRSyncController = (NiRTTI *)0x02F935D0;
const NiRTTI * NiRTTI_bhkCartTether = (NiRTTI *)0x02F94D38;
const NiRTTI * NiRTTI_bhkTiltPreventAction = (NiRTTI *)0x02F94D48;
const NiRTTI * NiRTTI_bhkWheelAction = (NiRTTI *)0x02F94D58;
const NiRTTI * NiRTTI_BSFaceGenAnimationData = (NiRTTI *)0x02F95398;
const NiRTTI * NiRTTI_BSFaceGenModelExtraData = (NiRTTI *)0x02F9B8C0;
const NiRTTI * NiRTTI_BSFaceGenBaseMorphExtraData = (NiRTTI *)0x02F9B8E8;
const NiRTTI * NiRTTI_BSFaceGenMorphData = (NiRTTI *)0x02F9B8F8;
const NiRTTI * NiRTTI_BSFaceGenMorphDataHead = (NiRTTI *)0x02F9B908;
const NiRTTI * NiRTTI_BSFaceGenMorphDataHair = (NiRTTI *)0x02F9B918;
const NiRTTI * NiRTTI_BSFaceGenNiNode = (NiRTTI *)0x02F9B958;
const NiRTTI * NiRTTI_BSTempEffect = (NiRTTI *)0x02FA0D28;
const NiRTTI * NiRTTI_BSTempEffectDebris = (NiRTTI *)0x02FA0DA8;
const NiRTTI * NiRTTI_BSTempEffectGeometryDecal = (NiRTTI *)0x02FA0DC8;
const NiRTTI * NiRTTI_BSTempEffectParticle = (NiRTTI *)0x02FA0E78;
const NiRTTI * NiRTTI_BSTempEffectSimpleDecal = (NiRTTI *)0x02FA0EA0;
const NiRTTI * NiRTTI_BSTempEffectSPG = (NiRTTI *)0x02FA0EB8;
const NiRTTI * NiRTTI_bhkAutoWater = (NiRTTI *)0x02FB8290;
const NiRTTI * NiRTTI_ModelReferenceEffect = (NiRTTI *)0x02FB9E28;
const NiRTTI * NiRTTI_ReferenceEffect = (NiRTTI *)0x02FB9E60;
const NiRTTI * NiRTTI_ShaderReferenceEffect = (NiRTTI *)0x02FB9E90;
const NiRTTI * NiRTTI_SummonPlacementEffect = (NiRTTI *)0x02FB9EC0;
const NiRTTI * NiRTTI_SceneGraph = (NiRTTI *)0x02FCD948;
const NiRTTI * NiRTTI_BSDoorHavokController = (NiRTTI *)0x02FCF668;
const NiRTTI * NiRTTI_BSPlayerDistanceCheckController = (NiRTTI *)0x02FCF678;
const NiRTTI * NiRTTI_BSSimpleScaleController = (NiRTTI *)0x02FCF688;
const NiRTTI * NiRTTI_NiObject = (NiRTTI *)0x030A71F0;
const NiRTTI * NiRTTI_NiAVObject = (NiRTTI *)0x030A7228;
const NiRTTI * NiRTTI_NiNode = (NiRTTI *)0x030A7248;
const NiRTTI * NiRTTI_NiObjectNET = (NiRTTI *)0x030A7388;
const NiRTTI * NiRTTI_NiLight = (NiRTTI *)0x030A73E0;
const NiRTTI * NiRTTI_NiSwitchNode = (NiRTTI *)0x030A73F0;
const NiRTTI * NiRTTI_NiStringsExtraData = (NiRTTI *)0x030A7400;
const NiRTTI * NiRTTI_NiCamera = (NiRTTI *)0x030A7410;
const NiRTTI * NiRTTI_BSTriShape = (NiRTTI *)0x030A7428;
const NiRTTI * NiRTTI_NiProperty = (NiRTTI *)0x030A7438;
const NiRTTI * NiRTTI_NiAlphaProperty = (NiRTTI *)0x030A7450;
const NiRTTI * NiRTTI_NiSourceTexture = (NiRTTI *)0x030A8488;
const NiRTTI * NiRTTI_BSFlattenedBoneTree = (NiRTTI *)0x030A8498;
const NiRTTI * NiRTTI_BSDismemberSkinInstance = (NiRTTI *)0x030A84E0;
const NiRTTI * NiRTTI_NiStringExtraData = (NiRTTI *)0x030A84F0;
const NiRTTI * NiRTTI_NiTimeController = (NiRTTI *)0x030A8500;
const NiRTTI * NiRTTI_NiExtraData = (NiRTTI *)0x030A8520;
const NiRTTI * NiRTTI_NiGeometryData = (NiRTTI *)0x030A8530;
const NiRTTI * NiRTTI_BSGeometry = (NiRTTI *)0x030A8548;
const NiRTTI * NiRTTI_BSDynamicTriShape = (NiRTTI *)0x030A8560;
const NiRTTI * NiRTTI_NiPointLight = (NiRTTI *)0x030A8570;
const NiRTTI * NiRTTI_NiDefaultAVObjectPalette = (NiRTTI *)0x030A8580;
const NiRTTI * NiRTTI_NiBillboardNode = (NiRTTI *)0x030A85A8;
const NiRTTI * NiRTTI_NiDirectionalLight = (NiRTTI *)0x030A85B8;
const NiRTTI * NiRTTI_NiCullingProcess = (NiRTTI *)0x030A85C8;
const NiRTTI * NiRTTI_NiParticles = (NiRTTI *)0x030A85E0;
const NiRTTI * NiRTTI_NiTexture = (NiRTTI *)0x030A8620;
const NiRTTI * NiRTTI_NiSkinPartition = (NiRTTI *)0x030A8730;
const NiRTTI * NiRTTI_NiVertWeightsExtraData = (NiRTTI *)0x030A8740;
const NiRTTI * NiRTTI_NiSkinInstance = (NiRTTI *)0x030A8750;
const NiRTTI * NiRTTI_NiAVObjectPalette = (NiRTTI *)0x030A8760;
const NiRTTI * NiRTTI_NiGeometry = (NiRTTI *)0x030A8770;
const NiRTTI * NiRTTI_NiSkinData = (NiRTTI *)0x030A87A0;
const NiRTTI * NiRTTI_NiShadeProperty = (NiRTTI *)0x030A87B0;
const NiRTTI * NiRTTI_NiAlphaAccumulator = (NiRTTI *)0x030A87C8;
const NiRTTI * NiRTTI_NiAmbientLight = (NiRTTI *)0x030A87D8;
const NiRTTI * NiRTTI_NiBinaryExtraData = (NiRTTI *)0x030A87E8;
const NiRTTI * NiRTTI_NiBooleanExtraData = (NiRTTI *)0x030A87F8;
const NiRTTI * NiRTTI_NiBSPNode = (NiRTTI *)0x030A8808;
const NiRTTI * NiRTTI_NiColorExtraData = (NiRTTI *)0x030A8818;
const NiRTTI * NiRTTI_NiFloatExtraData = (NiRTTI *)0x030A8828;
const NiRTTI * NiRTTI_NiFloatsExtraData = (NiRTTI *)0x030A8838;
const NiRTTI * NiRTTI_NiFogProperty = (NiRTTI *)0x030A8848;
const NiRTTI * NiRTTI_NiIntegerExtraData = (NiRTTI *)0x030A8860;
const NiRTTI * NiRTTI_NiIntegersExtraData = (NiRTTI *)0x030A8870;
const NiRTTI * NiRTTI_NiParticlesData = (NiRTTI *)0x030A88B8;
const NiRTTI * NiRTTI_NiParticleMeshesData = (NiRTTI *)0x030A88C8;
const NiRTTI * NiRTTI_NiParticleMeshes = (NiRTTI *)0x030A88D8;
const NiRTTI * NiRTTI_NiSpotLight = (NiRTTI *)0x030A88E8;
const NiRTTI * NiRTTI_NiSwitchStringExtraData = (NiRTTI *)0x030A88F8;
const NiRTTI * NiRTTI_NiTriShapeData = (NiRTTI *)0x030A8908;
const NiRTTI * NiRTTI_NiTriShape = (NiRTTI *)0x030A8918;
const NiRTTI * NiRTTI_NiTriStripsData = (NiRTTI *)0x030A8928;
const NiRTTI * NiRTTI_NiTriStrips = (NiRTTI *)0x030A8938;
const NiRTTI * NiRTTI_NiVectorExtraData = (NiRTTI *)0x030A8948;
const NiRTTI * NiRTTI_BSLODTriShape = (NiRTTI *)0x030A8970;
const NiRTTI * NiRTTI_NiAdditionalGeometryData = (NiRTTI *)0x030A8980;
const NiRTTI * NiRTTI_BSSegmentedTriShape = (NiRTTI *)0x030A8998;
const NiRTTI * NiRTTI_NiBackToFrontAccumulator = (NiRTTI *)0x030A89D0;
const NiRTTI * NiRTTI_NiAccumulator = (NiRTTI *)0x030A89E0;
const NiRTTI * NiRTTI_NiTriBasedGeomData = (NiRTTI *)0x030A89F0;
const NiRTTI * NiRTTI_NiTriBasedGeom = (NiRTTI *)0x030A8A00;
const NiRTTI * NiRTTI_NiCollisionData = (NiRTTI *)0x030A8A40;
const NiRTTI * NiRTTI_NiControllerManager = (NiRTTI *)0x030A8AD8;
const NiRTTI * NiRTTI_NiControllerSequence = (NiRTTI *)0x030A8AF8;
const NiRTTI * NiRTTI_NiBlendInterpolator = (NiRTTI *)0x030A8B28;
const NiRTTI * NiRTTI_NiMultiTargetTransformController = (NiRTTI *)0x030A8B38;
const NiRTTI * NiRTTI_BSMultiTargetTreadTransfController = (NiRTTI *)0x030A8B48;
const NiRTTI * NiRTTI_NiInterpController = (NiRTTI *)0x030A8B58;
const NiRTTI * NiRTTI_NiFloatData = (NiRTTI *)0x030A9928;
const NiRTTI * NiRTTI_NiFloatInterpolator = (NiRTTI *)0x030A9938;
const NiRTTI * NiRTTI_NiColorData = (NiRTTI *)0x030A9948;
const NiRTTI * NiRTTI_NiColorInterpolator = (NiRTTI *)0x030A9958;
const NiRTTI * NiRTTI_NiSingleInterpController = (NiRTTI *)0x030A9968;
const NiRTTI * NiRTTI_NiTransformInterpolator = (NiRTTI *)0x030A9978;
const NiRTTI * NiRTTI_NiPathInterpolator = (NiRTTI *)0x030A9988;
const NiRTTI * NiRTTI_NiBlendTransformInterpolator = (NiRTTI *)0x030A99A8;
const NiRTTI * NiRTTI_NiBlendFloatInterpolator = (NiRTTI *)0x030A99B8;
const NiRTTI * NiRTTI_NiFloatExtraDataController = (NiRTTI *)0x030A99C8;
const NiRTTI * NiRTTI_NiTransformController = (NiRTTI *)0x030A99D8;
const NiRTTI * NiRTTI_NiBlendAccumTransformInterpolator = (NiRTTI *)0x030A99E8;
const NiRTTI * NiRTTI_NiInterpolator = (NiRTTI *)0x030A9A00;
const NiRTTI * NiRTTI_BSBlendTreadTransfInterpolator = (NiRTTI *)0x030A9A20;
const NiRTTI * NiRTTI_NiKeyBasedInterpolator = (NiRTTI *)0x030A9A38;
const NiRTTI * NiRTTI_NiTransformData = (NiRTTI *)0x030A9AB8;
const NiRTTI * NiRTTI_NiPosData = (NiRTTI *)0x030A9AC8;
const NiRTTI * NiRTTI_NiBlendBoolInterpolator = (NiRTTI *)0x030A9AD8;
const NiRTTI * NiRTTI_NiBlendColorInterpolator = (NiRTTI *)0x030A9AE8;
const NiRTTI * NiRTTI_NiBlendPoint3Interpolator = (NiRTTI *)0x030A9AF8;
const NiRTTI * NiRTTI_NiBlendQuaternionInterpolator = (NiRTTI *)0x030A9B08;
const NiRTTI * NiRTTI_NiBoolData = (NiRTTI *)0x030A9B18;
const NiRTTI * NiRTTI_NiBoolInterpolator = (NiRTTI *)0x030A9B28;
const NiRTTI * NiRTTI_NiBoolTimelineInterpolator = (NiRTTI *)0x030A9B38;
const NiRTTI * NiRTTI_NiBSplineBasisData = (NiRTTI *)0x030A9B48;
const NiRTTI * NiRTTI_NiBSplineData = (NiRTTI *)0x030A9B58;
const NiRTTI * NiRTTI_NiBSplineColorInterpolator = (NiRTTI *)0x030A9B68;
const NiRTTI * NiRTTI_NiBSplineCompColorInterpolator = (NiRTTI *)0x030A9B78;
const NiRTTI * NiRTTI_NiBSplineCompFloatInterpolator = (NiRTTI *)0x030A9B88;
const NiRTTI * NiRTTI_NiBSplineCompPoint3Interpolator = (NiRTTI *)0x030A9B98;
const NiRTTI * NiRTTI_NiBSplineCompTransformInterpolator = (NiRTTI *)0x030A9BA8;
const NiRTTI * NiRTTI_NiBSplineFloatInterpolator = (NiRTTI *)0x030A9BB8;
const NiRTTI * NiRTTI_NiBSplinePoint3Interpolator = (NiRTTI *)0x030A9BC8;
const NiRTTI * NiRTTI_NiBSplineTransformInterpolator = (NiRTTI *)0x030A9BD8;
const NiRTTI * NiRTTI_NiColorExtraDataController = (NiRTTI *)0x030A9BE8;
const NiRTTI * NiRTTI_NiFloatsExtraDataController = (NiRTTI *)0x030A9BF8;
const NiRTTI * NiRTTI_NiFloatsExtraDataPoint3Controller = (NiRTTI *)0x030A9C08;
const NiRTTI * NiRTTI_NiKeyframeManager = (NiRTTI *)0x030A9C20;
const NiRTTI * NiRTTI_NiLightColorController = (NiRTTI *)0x030A9C30;
const NiRTTI * NiRTTI_NiLightDimmerController = (NiRTTI *)0x030A9C40;
const NiRTTI * NiRTTI_NiLookAtController = (NiRTTI *)0x030A9C50;
const NiRTTI * NiRTTI_NiLookAtInterpolator = (NiRTTI *)0x030A9C60;
const NiRTTI * NiRTTI_NiMorphData = (NiRTTI *)0x030A9C70;
const NiRTTI * NiRTTI_NiPathController = (NiRTTI *)0x030A9C80;
const NiRTTI * NiRTTI_NiPoint3Interpolator = (NiRTTI *)0x030A9C90;
const NiRTTI * NiRTTI_NiQuaternionInterpolator = (NiRTTI *)0x030A9CA0;
const NiRTTI * NiRTTI_NiRollController = (NiRTTI *)0x030A9CB0;
const NiRTTI * NiRTTI_NiRotData = (NiRTTI *)0x030A9CC0;
const NiRTTI * NiRTTI_NiSequence = (NiRTTI *)0x030A9CD0;
const NiRTTI * NiRTTI_NiSequenceStreamHelper = (NiRTTI *)0x030A9CF0;
const NiRTTI * NiRTTI_NiStringPalette = (NiRTTI *)0x030A9D00;
const NiRTTI * NiRTTI_NiTextKeyExtraData = (NiRTTI *)0x030A9D10;
const NiRTTI * NiRTTI_NiUVData = (NiRTTI *)0x030A9D20;
const NiRTTI * NiRTTI_NiVisController = (NiRTTI *)0x030A9D30;
const NiRTTI * NiRTTI_BSAnimNote = (NiRTTI *)0x030A9D40;
const NiRTTI * NiRTTI_BSAnimNotes = (NiRTTI *)0x030A9D50;
const NiRTTI * NiRTTI_BSGrabIKNote = (NiRTTI *)0x030A9D60;
const NiRTTI * NiRTTI_BSLookIKNote = (NiRTTI *)0x030A9D70;
const NiRTTI * NiRTTI_BSRotAccumTransfInterpolator = (NiRTTI *)0x030A9D80;
const NiRTTI * NiRTTI_BSTreadTransfInterpolator = (NiRTTI *)0x030A9D90;
const NiRTTI * NiRTTI_BSFrustumFOVController = (NiRTTI *)0x030A9DA0;
const NiRTTI * NiRTTI_NiExtraDataController = (NiRTTI *)0x030A9E38;
const NiRTTI * NiRTTI_NiBSplineInterpolator = (NiRTTI *)0x030A9E48;
const NiRTTI * NiRTTI_NiPoint3InterpController = (NiRTTI *)0x030A9E58;
const NiRTTI * NiRTTI_NiFloatInterpController = (NiRTTI *)0x030A9E68;
const NiRTTI * NiRTTI_NiFloatController = (NiRTTI *)0x030A9E78;
const NiRTTI * NiRTTI_NiBoolInterpController = (NiRTTI *)0x030A9E88;
const NiRTTI * NiRTTI_NiParticleSystem = (NiRTTI *)0x030A9EA0;
const NiRTTI * NiRTTI_NiPSysEmitterCtlr = (NiRTTI *)0x030A9EB0;
const NiRTTI * NiRTTI_NiPSysGravityModifier = (NiRTTI *)0x030A9EC0;
const NiRTTI * NiRTTI_BSPSysHavokUpdateModifier = (NiRTTI *)0x030A9ED0;
const NiRTTI * NiRTTI_NiMeshParticleSystem = (NiRTTI *)0x030A9EE8;
const NiRTTI * NiRTTI_NiPSysCylinderEmitter = (NiRTTI *)0x030A9F00;
const NiRTTI * NiRTTI_BSStripParticleSystem = (NiRTTI *)0x030A9F10;
const NiRTTI * NiRTTI_NiPSysEmitter = (NiRTTI *)0x030A9F20;
const NiRTTI * NiRTTI_NiPSysModifierCtlr = (NiRTTI *)0x030A9F30;
const NiRTTI * NiRTTI_NiPSysModifier = (NiRTTI *)0x030A9F48;
const NiRTTI * NiRTTI_NiPSysMeshUpdateModifier = (NiRTTI *)0x030A9F58;
const NiRTTI * NiRTTI_NiPSysUpdateCtlr = (NiRTTI *)0x030A9F68;
const NiRTTI * NiRTTI_NiMeshPSysData = (NiRTTI *)0x030A9F78;
const NiRTTI * NiRTTI_NiPSysAirFieldAirFrictionCtlr = (NiRTTI *)0x030A9F88;
const NiRTTI * NiRTTI_NiPSysAirFieldInheritVelocityCtlr = (NiRTTI *)0x030A9F98;
const NiRTTI * NiRTTI_NiPSysAirFieldModifier = (NiRTTI *)0x030A9FA8;
const NiRTTI * NiRTTI_NiPSysAirFieldSpreadCtlr = (NiRTTI *)0x030A9FB8;
const NiRTTI * NiRTTI_NiPSysAgeDeathModifier = (NiRTTI *)0x030A9FC8;
const NiRTTI * NiRTTI_NiPSysBombModifier = (NiRTTI *)0x030A9FD8;
const NiRTTI * NiRTTI_NiPSysBoundUpdateModifier = (NiRTTI *)0x030A9FE8;
const NiRTTI * NiRTTI_NiPSysBoxEmitter = (NiRTTI *)0x030A9FF8;
const NiRTTI * NiRTTI_NiPSysColliderManager = (NiRTTI *)0x030AA008;
const NiRTTI * NiRTTI_NiPSysColorModifier = (NiRTTI *)0x030AA018;
const NiRTTI * NiRTTI_NiPSysData = (NiRTTI *)0x030AA028;
const NiRTTI * NiRTTI_NiPSysDragFieldModifier = (NiRTTI *)0x030AA038;
const NiRTTI * NiRTTI_NiPSysDragModifier = (NiRTTI *)0x030AA048;
const NiRTTI * NiRTTI_NiPSysEmitterCtlrData = (NiRTTI *)0x030AA058;
const NiRTTI * NiRTTI_NiPSysEmitterDeclinationCtlr = (NiRTTI *)0x030AA068;
const NiRTTI * NiRTTI_NiPSysEmitterDeclinationVarCtlr = (NiRTTI *)0x030AA078;
const NiRTTI * NiRTTI_NiPSysEmitterInitialRadiusCtlr = (NiRTTI *)0x030AA088;
const NiRTTI * NiRTTI_NiPSysEmitterLifeSpanCtlr = (NiRTTI *)0x030AA098;
const NiRTTI * NiRTTI_NiPSysEmitterPlanarAngleCtlr = (NiRTTI *)0x030AA0A8;
const NiRTTI * NiRTTI_NiPSysEmitterPlanarAngleVarCtlr = (NiRTTI *)0x030AA0B8;
const NiRTTI * NiRTTI_NiPSysEmitterSpeedCtlr = (NiRTTI *)0x030AA0C8;
const NiRTTI * NiRTTI_NiPSysFieldAttenuationCtlr = (NiRTTI *)0x030AA0D8;
const NiRTTI * NiRTTI_NiPSysFieldMagnitudeCtlr = (NiRTTI *)0x030AA0E8;
const NiRTTI * NiRTTI_NiPSysFieldMaxDistanceCtlr = (NiRTTI *)0x030AA0F8;
const NiRTTI * NiRTTI_NiPSysGravityFieldModifier = (NiRTTI *)0x030AA108;
const NiRTTI * NiRTTI_NiPSysGravityStrengthCtlr = (NiRTTI *)0x030AA118;
const NiRTTI * NiRTTI_NiPSysGrowFadeModifier = (NiRTTI *)0x030AA128;
const NiRTTI * NiRTTI_NiPSysInitialRotAngleCtlr = (NiRTTI *)0x030AA138;
const NiRTTI * NiRTTI_NiPSysInitialRotAngleVarCtlr = (NiRTTI *)0x030AA148;
const NiRTTI * NiRTTI_NiPSysInitialRotSpeedCtlr = (NiRTTI *)0x030AA158;
const NiRTTI * NiRTTI_NiPSysInitialRotSpeedVarCtlr = (NiRTTI *)0x030AA168;
const NiRTTI * NiRTTI_NiPSysMeshEmitter = (NiRTTI *)0x030AA178;
const NiRTTI * NiRTTI_NiPSysModifierActiveCtlr = (NiRTTI *)0x030AA1A8;
const NiRTTI * NiRTTI_NiPSysPlanarCollider = (NiRTTI *)0x030AA1B8;
const NiRTTI * NiRTTI_NiPSysPositionModifier = (NiRTTI *)0x030AA1C8;
const NiRTTI * NiRTTI_NiPSysRadialFieldModifier = (NiRTTI *)0x030AA1D8;
const NiRTTI * NiRTTI_NiPSysResetOnLoopCtlr = (NiRTTI *)0x030AA1E8;
const NiRTTI * NiRTTI_NiPSysRotationModifier = (NiRTTI *)0x030AA1F8;
const NiRTTI * NiRTTI_NiPSysSpawnModifier = (NiRTTI *)0x030AA208;
const NiRTTI * NiRTTI_NiPSysSphereEmitter = (NiRTTI *)0x030AA218;
const NiRTTI * NiRTTI_NiPSysSphericalCollider = (NiRTTI *)0x030AA228;
const NiRTTI * NiRTTI_NiPSysTurbulenceFieldModifier = (NiRTTI *)0x030AA238;
const NiRTTI * NiRTTI_NiPSysVortexFieldModifier = (NiRTTI *)0x030AA248;
const NiRTTI * NiRTTI_BSStripPSysData = (NiRTTI *)0x030AA258;
const NiRTTI * NiRTTI_BSPSysRecycleBoundModifier = (NiRTTI *)0x030AA270;
const NiRTTI * NiRTTI_BSPSysInheritVelocityModifier = (NiRTTI *)0x030AA280;
const NiRTTI * NiRTTI_NiPSysVolumeEmitter = (NiRTTI *)0x030AA290;
const NiRTTI * NiRTTI_NiPSysModifierFloatCtlr = (NiRTTI *)0x030AA2A0;
const NiRTTI * NiRTTI_NiPSysFieldModifier = (NiRTTI *)0x030AA2B0;
const NiRTTI * NiRTTI_NiPSysModifierBoolCtlr = (NiRTTI *)0x030AA2C0;
const NiRTTI * NiRTTI_NiPSysCollider = (NiRTTI *)0x030AA2D0;
const NiRTTI * NiRTTI_BSMultiBound = (NiRTTI *)0x030B2588;
const NiRTTI * NiRTTI_BSMultiBoundRoom = (NiRTTI *)0x030B2598;
const NiRTTI * NiRTTI_BSMultiBoundAABB = (NiRTTI *)0x030B25B0;
const NiRTTI * NiRTTI_BSMultiBoundOBB = (NiRTTI *)0x030B25C8;
const NiRTTI * NiRTTI_BSXFlags = (NiRTTI *)0x030B25E8;
const NiRTTI * NiRTTI_BSValueNode = (NiRTTI *)0x030B2600;
const NiRTTI * NiRTTI_BSWindModifier = (NiRTTI *)0x030B8B80;
const NiRTTI * NiRTTI_BSTempNodeManager = (NiRTTI *)0x030B8BA0;
const NiRTTI * NiRTTI_BSTempNode = (NiRTTI *)0x030B8BB0;
const NiRTTI * NiRTTI_BSOcclusionShape = (NiRTTI *)0x030B8BD0;
const NiRTTI * NiRTTI_BSRangeNode = (NiRTTI *)0x030B8CC8;
const NiRTTI * NiRTTI_BSBlastNode = (NiRTTI *)0x030B8F00;
const NiRTTI * NiRTTI_BSDebrisNode = (NiRTTI *)0x030B8F10;
const NiRTTI * NiRTTI_BSDamageStage = (NiRTTI *)0x030B8F20;
const NiRTTI * NiRTTI_BSPSysArrayEmitter = (NiRTTI *)0x030B8F30;
const NiRTTI * NiRTTI_PArrayPoint = (NiRTTI *)0x030B8F40;
const NiRTTI * NiRTTI_BSMultiStreamInstanceTriShape = (NiRTTI *)0x030B8F68;
const NiRTTI * NiRTTI_BSMultiBoundShape = (NiRTTI *)0x030B8F98;
const NiRTTI * NiRTTI_BSMultiBoundSphere = (NiRTTI *)0x030B8FA8;
const NiRTTI * NiRTTI_BSOcclusionBox = (NiRTTI *)0x030B8FC0;
const NiRTTI * NiRTTI_BSOcclusionPlane = (NiRTTI *)0x030B8FD8;
const NiRTTI * NiRTTI_BSPortal = (NiRTTI *)0x030B8FE8;
const NiRTTI * NiRTTI_BSPortalSharedNode = (NiRTTI *)0x030B8FF8;
const NiRTTI * NiRTTI_BSBodyMorphOffsetsExtraData = (NiRTTI *)0x030B9010;
const NiRTTI * NiRTTI_BSBehaviorGraphExtraData = (NiRTTI *)0x030B9020;
const NiRTTI * NiRTTI_NiBSBoneLODController = (NiRTTI *)0x030B9038;
const NiRTTI * NiRTTI_BSCullingProcess = (NiRTTI *)0x030B9058;
const NiRTTI * NiRTTI_BSParticleSystemManager = (NiRTTI *)0x030B9078;
const NiRTTI * NiRTTI_BSFurnitureMarkerNode = (NiRTTI *)0x030B90A0;
const NiRTTI * NiRTTI_BSBound = (NiRTTI *)0x030B9120;
const NiRTTI * NiRTTI_BSMultiBoundNode = (NiRTTI *)0x030B9140;
const NiRTTI * NiRTTI_BSBoneMap = (NiRTTI *)0x030B9150;
const NiRTTI * NiRTTI_BSAnimInteractionMarker = (NiRTTI *)0x030B9168;
const NiRTTI * NiRTTI_BSSceneGraph = (NiRTTI *)0x030B9180;
const NiRTTI * NiRTTI_BSPSysMultiTargetEmitterCtlr = (NiRTTI *)0x030B9198;
const NiRTTI * NiRTTI_BSGeometryListCullingProcess = (NiRTTI *)0x030B91B0;
const NiRTTI * NiRTTI_BSSubIndexTriShape = (NiRTTI *)0x030B91C8;
const NiRTTI * NiRTTI_BSDistantObjectLargeRefExtraData = (NiRTTI *)0x030B91D8;
const NiRTTI * NiRTTI_BSMasterParticleSystem = (NiRTTI *)0x030BABA0;
const NiRTTI * NiRTTI_BSProceduralLightningController = (NiRTTI *)0x030BABC8;
const NiRTTI * NiRTTI_BSInvMarker = (NiRTTI *)0x030BABD8;
const NiRTTI * NiRTTI_BSBoneLODExtraData = (NiRTTI *)0x030BABF0;
const NiRTTI * NiRTTI_BSReference = (NiRTTI *)0x030BAC10;
const NiRTTI * NiRTTI_BSNodeReferences = (NiRTTI *)0x030BAC20;
const NiRTTI * NiRTTI_BSDecalPlacementVectorExtraData = (NiRTTI *)0x030BAC30;
const NiRTTI * NiRTTI_BSParentVelocityModifier = (NiRTTI *)0x030BAC40;
const NiRTTI * NiRTTI_BSWArray = (NiRTTI *)0x030BAC50;
const NiRTTI * NiRTTI_BSMultiBoundCapsule = (NiRTTI *)0x030BAC68;
const NiRTTI * NiRTTI_BSPSysStripUpdateModifier = (NiRTTI *)0x030BAC78;
const NiRTTI * NiRTTI_BSPSysSubTexModifier = (NiRTTI *)0x030BAC88;
const NiRTTI * NiRTTI_BSPSysScaleModifier = (NiRTTI *)0x030BAC98;
const NiRTTI * NiRTTI_BSLagBoneController = (NiRTTI *)0x030BACA8;
const NiRTTI * NiRTTI_BSNonUniformScaleExtraData = (NiRTTI *)0x030BACB8;
const NiRTTI * NiRTTI_BSNiNode = (NiRTTI *)0x030BACD0;
const NiRTTI * NiRTTI_BSInstanceTriShape = (NiRTTI *)0x030BACE0;
const NiRTTI * NiRTTI_bhkWorldObject = (NiRTTI *)0x030C11D8;
const NiRTTI * NiRTTI_bhkWorld = (NiRTTI *)0x030C1218;
const NiRTTI * NiRTTI_bhkRigidBody = (NiRTTI *)0x030C2358;
const NiRTTI * NiRTTI_bhkCollisionObject = (NiRTTI *)0x030C2370;
const NiRTTI * NiRTTI_bhkNiCollisionObject = (NiRTTI *)0x030C2420;
const NiRTTI * NiRTTI_bhkAttachmentCollisionObject = (NiRTTI *)0x030C24A0;
const NiRTTI * NiRTTI_WeaponObject = (NiRTTI *)0x030C24B0;
const NiRTTI * NiRTTI_bhkRigidBodyT = (NiRTTI *)0x030C24D8;
const NiRTTI * NiRTTI_bhkWorldM = (NiRTTI *)0x030C24E8;
const NiRTTI * NiRTTI_bhkRefObject = (NiRTTI *)0x030C2510;
const NiRTTI * NiRTTI_bhkSerializable = (NiRTTI *)0x030C2520;
const NiRTTI * NiRTTI_bhkShape = (NiRTTI *)0x030C2550;
const NiRTTI * NiRTTI_bhkEntity = (NiRTTI *)0x030C2568;
const NiRTTI * NiRTTI_bhkPhantom = (NiRTTI *)0x030C2580;
const NiRTTI * NiRTTI_bhkAabbPhantom = (NiRTTI *)0x030C2598;
const NiRTTI * NiRTTI_bhkSphereRepShape = (NiRTTI *)0x030C25B0;
const NiRTTI * NiRTTI_bhkConvexShape = (NiRTTI *)0x030C25C8;
const NiRTTI * NiRTTI_bhkPCollisionObject = (NiRTTI *)0x030C25D8;
const NiRTTI * NiRTTI_hkPackedNiTriStripsData = (NiRTTI *)0x030C25E8;
const NiRTTI * NiRTTI_bhkShapePhantom = (NiRTTI *)0x030C2600;
const NiRTTI * NiRTTI_bhkSimpleShapePhantom = (NiRTTI *)0x030C2618;
const NiRTTI * NiRTTI_bhkCapsuleShape = (NiRTTI *)0x030C2630;
const NiRTTI * NiRTTI_bhkBoxShape = (NiRTTI *)0x030C2648;
const NiRTTI * NiRTTI_bhkSphereShape = (NiRTTI *)0x030C2660;
const NiRTTI * NiRTTI_bhkBvTreeShape = (NiRTTI *)0x030C2678;
const NiRTTI * NiRTTI_bhkNiTriStripsShape = (NiRTTI *)0x030C2690;
const NiRTTI * NiRTTI_bhkPackedNiTriStripsShape = (NiRTTI *)0x030C26B8;
const NiRTTI * NiRTTI_bhkBlendCollisionObject = (NiRTTI *)0x030C26D0;
const NiRTTI * NiRTTI_bhkAvoidBox = (NiRTTI *)0x030C26F0;
const NiRTTI * NiRTTI_bhkLimitedHingeConstraint = (NiRTTI *)0x030C2708;
const NiRTTI * NiRTTI_bhkMalleableConstraint = (NiRTTI *)0x030C2720;
const NiRTTI * NiRTTI_bhkUnaryAction = (NiRTTI *)0x030C2738;
const NiRTTI * NiRTTI_bhkConstraint = (NiRTTI *)0x030C2750;
const NiRTTI * NiRTTI_bhkPrismaticConstraint = (NiRTTI *)0x030C2768;
const NiRTTI * NiRTTI_bhkAction = (NiRTTI *)0x030C2780;
const NiRTTI * NiRTTI_bhkTriSampledHeightFieldBvTreeShape = (NiRTTI *)0x030C2798;
const NiRTTI * NiRTTI_bhkCachingShapePhantom = (NiRTTI *)0x030C3408;
const NiRTTI * NiRTTI_bhkRagdollTemplateData = (NiRTTI *)0x030C3430;
const NiRTTI * NiRTTI_bhkRagdollTemplate = (NiRTTI *)0x030C3440;
const NiRTTI * NiRTTI_bhkSPCollisionObject = (NiRTTI *)0x030C3450;
const NiRTTI * NiRTTI_bhkMouseSpringAction = (NiRTTI *)0x030C3468;
const NiRTTI * NiRTTI_bhkHingeConstraint = (NiRTTI *)0x030C3480;
const NiRTTI * NiRTTI_bhkCompressedMeshShape = (NiRTTI *)0x030C34F8;
const NiRTTI * NiRTTI_bhkCompressedMeshShapeData = (NiRTTI *)0x030C3508;
const NiRTTI * NiRTTI_bhkConvexSweepShape = (NiRTTI *)0x030C3520;
const NiRTTI * NiRTTI_bhkConvexTransformShape = (NiRTTI *)0x030C3538;
const NiRTTI * NiRTTI_bhkConvexTranslateShape = (NiRTTI *)0x030C3550;
const NiRTTI * NiRTTI_bhkConvexVerticesShape = (NiRTTI *)0x030C3568;
const NiRTTI * NiRTTI_bhkCylinderShape = (NiRTTI *)0x030C3580;
const NiRTTI * NiRTTI_bhkMultiSphereShape = (NiRTTI *)0x030C3598;
const NiRTTI * NiRTTI_bhkPlaneShape = (NiRTTI *)0x030C35B0;
const NiRTTI * NiRTTI_bhkTriangleShape = (NiRTTI *)0x030C35C8;
const NiRTTI * NiRTTI_bhkMoppBvTreeShape = (NiRTTI *)0x030C35E0;
const NiRTTI * NiRTTI_bhkTransformShape = (NiRTTI *)0x030C35F8;
const NiRTTI * NiRTTI_bhkListShape = (NiRTTI *)0x030C3610;
const NiRTTI * NiRTTI_bhkBallAndSocketConstraint = (NiRTTI *)0x030C3628;
const NiRTTI * NiRTTI_bhkBallSocketConstraintChain = (NiRTTI *)0x030C3640;
const NiRTTI * NiRTTI_bhkGroupConstraint = (NiRTTI *)0x030C3658;
const NiRTTI * NiRTTI_bhkHingeLimitsConstraint = (NiRTTI *)0x030C3670;
const NiRTTI * NiRTTI_bhkFixedConstraint = (NiRTTI *)0x030C3688;
const NiRTTI * NiRTTI_bhkRagdollConstraint = (NiRTTI *)0x030C36A0;
const NiRTTI * NiRTTI_bhkRagdollLimitsConstraint = (NiRTTI *)0x030C36B8;
const NiRTTI * NiRTTI_bhkStiffSpringConstraint = (NiRTTI *)0x030C36D0;
const NiRTTI * NiRTTI_bhkWheelConstraint = (NiRTTI *)0x030C36E8;
const NiRTTI * NiRTTI_bhkBreakableConstraint = (NiRTTI *)0x030C3700;
const NiRTTI * NiRTTI_bhkAngularDashpotAction = (NiRTTI *)0x030C3718;
const NiRTTI * NiRTTI_bhkDashpotAction = (NiRTTI *)0x030C3730;
const NiRTTI * NiRTTI_bhkLiquidAction = (NiRTTI *)0x030C3748;
const NiRTTI * NiRTTI_bhkMotorAction = (NiRTTI *)0x030C3768;
const NiRTTI * NiRTTI_bhkOrientHingedBodyAction = (NiRTTI *)0x030C3780;
const NiRTTI * NiRTTI_bhkSpringAction = (NiRTTI *)0x030C3798;
const NiRTTI * NiRTTI_bhkBlendController = (NiRTTI *)0x030C37A8;
const NiRTTI * NiRTTI_bhkExtraData = (NiRTTI *)0x030C37B8;
const NiRTTI * NiRTTI_bhkPoseArray = (NiRTTI *)0x030C37C8;
const NiRTTI * NiRTTI_bhkGenericConstraint = (NiRTTI *)0x030C37E8;
const NiRTTI * NiRTTI_bhkCharControllerShape = (NiRTTI *)0x030C37F8;
const NiRTTI * NiRTTI_bhkCollisionBox = (NiRTTI *)0x030C3810;
const NiRTTI * NiRTTI_bhkShapeCollection = (NiRTTI *)0x030C3828;
const NiRTTI * NiRTTI_bhkPositionConstraintMotor = (NiRTTI *)0x030C3890;
const NiRTTI * NiRTTI_bhkVelocityConstraintMotor = (NiRTTI *)0x030C38A0;
const NiRTTI * NiRTTI_bhkSpringDamperConstraintMotor = (NiRTTI *)0x030C38B0;
const NiRTTI * NiRTTI_bhkCharacterProxy = (NiRTTI *)0x030C4668;
const NiRTTI * NiRTTI_bhkCharacterRigidBody = (NiRTTI *)0x030C4680;
const NiRTTI * NiRTTI_bhkHeightFieldShape = (NiRTTI *)0x030C5988;
const NiRTTI * NiRTTI_bhkConstraintChain = (NiRTTI *)0x030C59A0;
const NiRTTI * NiRTTI_bhkBinaryAction = (NiRTTI *)0x030C59B8;
const NiRTTI * NiRTTI_bhkPointToPathConstraint = (NiRTTI *)0x030C59F0;
const NiRTTI * NiRTTI_DebugTextExtraData = (NiRTTI *)0x030C71F0;
const NiRTTI * NiRTTI_BSFadeNode = (NiRTTI *)0x03265168;
const NiRTTI * NiRTTI_BSShaderProperty = (NiRTTI *)0x03265198;
const NiRTTI * NiRTTI_BSLeafAnimNode = (NiRTTI *)0x032651A8;
const NiRTTI * NiRTTI_BSTreeNode = (NiRTTI *)0x032651B8;
const NiRTTI * NiRTTI_ShadowSceneNode = (NiRTTI *)0x032655E0;
const NiRTTI * NiRTTI_BSLightingShaderProperty = (NiRTTI *)0x03265EB0;
const NiRTTI * NiRTTI_BSGrassShaderProperty = (NiRTTI *)0x03265EE8;
const NiRTTI * NiRTTI_BSShaderAccumulator = (NiRTTI *)0x03266100;
const NiRTTI * NiRTTI_BSEffectShaderProperty = (NiRTTI *)0x032662A0;
const NiRTTI * NiRTTI_BSWaterShaderProperty = (NiRTTI *)0x032C70C8;
const NiRTTI * NiRTTI_BSBloodSplatterShaderProperty = (NiRTTI *)0x032C70D8;
const NiRTTI * NiRTTI_BSParticleShaderProperty = (NiRTTI *)0x032C74C8;
const NiRTTI * NiRTTI_BSTextureSet = (NiRTTI *)0x032C7818;
const NiRTTI * NiRTTI_BSShaderTextureSet = (NiRTTI *)0x032C7828;
const NiRTTI * NiRTTI_BSSkyShaderProperty = (NiRTTI *)0x032C7B28;
const NiRTTI * NiRTTI_BSFadeNodeCuller = (NiRTTI *)0x03317BB0;
const NiRTTI * NiRTTI_BSDistantTreeShaderProperty = (NiRTTI *)0x03317BE0;
const NiRTTI * NiRTTI_BSCubeMapCamera = (NiRTTI *)0x03317DC0;
const NiRTTI * NiRTTI_BSFogProperty = (NiRTTI *)0x03317E78;
const NiRTTI * NiRTTI_BSClearZNode = (NiRTTI *)0x03529F38;
const NiRTTI * NiRTTI_NiCollisionObject = (NiRTTI *)0x0352A058;
const NiRTTI * NiRTTI_BSOrderedNode = (NiRTTI *)0x0352A068;
const NiRTTI * NiRTTI_BSLines = (NiRTTI *)0x0352A078;
const NiRTTI * NiRTTI_BSDynamicLines = (NiRTTI *)0x0352A088;
const NiRTTI * NiRTTI_BSMultiIndexTriShape = (NiRTTI *)0x0352A0A8;
const NiRTTI * NiRTTI_BSLightingShaderPropertyFloatController = (NiRTTI *)0x0352A150;
const NiRTTI * NiRTTI_BSLightingShaderPropertyUShortController = (NiRTTI *)0x0352A168;
const NiRTTI * NiRTTI_BSLightingShaderPropertyColorController = (NiRTTI *)0x0352A180;
const NiRTTI * NiRTTI_BSEffectShaderPropertyFloatController = (NiRTTI *)0x0352A1B8;
const NiRTTI * NiRTTI_BSEffectShaderPropertyColorController = (NiRTTI *)0x0352A1D0;
const NiRTTI * NiRTTI_BSNiAlphaPropertyTestRefController = (NiRTTI *)0x0352A1E0;
const NiRTTI * NiRTTI_BSPSysSimpleColorModifier = (NiRTTI *)0x0352A1F0;
const NiRTTI * NiRTTI_BSPSysLODModifier = (NiRTTI *)0x0352A200;
const NiRTTI * NiRTTI_BSParabolicCullingProcess = (NiRTTI *)0x0352A688;
const NiRTTI * NiRTTI_BSMeshLODTriShape = (NiRTTI *)0x0352A698;
const NiRTTI * NiRTTI_BSLODMultiIndexTriShape = (NiRTTI *)0x0352A6A8;
const NiRTTI * NiRTTI_BSSubIndexLandTriShape = (NiRTTI *)0x0352A6C0;
